Debian Bug report logs - #432132
apt-cross: please add a --simulate option

version graph

Package: apt-cross; Maintainer for apt-cross is (unknown);

Reported by: Phil Endecott <spam_from_debian_bugs_2@chezphil.org>

Date: Thu, 31 May 2007 22:48:01 UTC

Severity: wishlist

Found in version apt-cross/0.1.0

Fixed in version apt-cross/0.3.0

Done: Neil Williams <codehelp@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#426944; Package apt-cross. Full text and rfc822 format available.

Acknowledgement sent to Phil Endecott <spam_from_debian_bugs_2@chezphil.org>:
New Bug report received and forwarded. Copy sent to Neil Williams <codehelp@debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Phil Endecott <spam_from_debian_bugs_2@chezphil.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: apt-cross: Silently fails with "-S stable" without --update
Date: Thu, 31 May 2007 23:43:27 +0100
Package: apt-cross
Version: 0.1.0
Severity: normal


Hi,

I've just tried apt-cross for the first time having previously used dpkg-cross.  
It looks like it should be a very helpful tool, and my first attempt worked:

# apt-cross -a arm --install librecode-dev

(One suggestion is that it could accept "install" as well as "--install", for 
more consistency with apt-get.  And a -s for simulate would also be 
appreciated.)

So that was OK but I soon realised that it had loaded librecode-dev for unstable, 
which has the new ABI!  So I uninstalled it, which worked, and tried to install 
an older version, from stable:

# apt-cross -a arm --remove librecode-dev
# apt-cross -a arm -S stable --install librecode-dev

This simply printed:

    One package to install.

straight away and did nothing else.

With "-S testing" it did seem to work: it downloaded the package files and 
then downloaded and installed the requested library and dependencies.

I eventually realised that I needed to do "apt-cross -a arm -S stable --update" 
first.  After that the --install worked fine.

So the bug is that for unstable and testing it seemed to automatically download 
the package files while for stable it didn't.  And/or, that without the package 
files it printed only a very terse message, not "no packages files, please run 
apt-cross --update".

Here is the contents of my sources.list, exluding commented-out lines, in case 
it is relevent :

deb http://ftp.uk.debian.org/debian stable main
deb http://ftp.uk.debian.org/debian/ testing main contrib
deb http://ftp.uk.debian.org/debian/ unstable main
deb-src http://ftp.uk.debian.org/debian/ unstable main
deb http://security.debian.org/ testing/updates main
deb http://tonelli.sns.it/pub/mplayer/etch ./
deb http://mirrors.ecology.uni-kiel.de/debian/debian-multimedia unstable main

Please excuse me if I am doing something stupid (or if you consider my 
expectations unreasonable!), and thank you for this excellent tool.

Regards,

Phil.


-- System Information:
Debian Release: testing/unstable
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: i386 (i686)
Shell:  /bin/sh linked to /bin/bash
Kernel: Linux 2.6.19
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)

Versions of packages apt-cross depends on:
ii  apt                           0.6.43.3   Advanced front-end for dpkg
ii  binutils                      2.17-1     The GNU assembler, linker and bina
ii  dpkg-cross                    1.28       tools for cross compiling Debian p
ii  dpkg-dev                      1.13.22    package building tools for Debian
ii  libfile-homedir-perl          0.64-1     Get the home directory for yoursel
ii  libwww-perl                   5.805-1    WWW client/server library for Perl
ii  sudo                          1.6.8p12-5 Provide limited super user privile

apt-cross recommends no packages.

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Neil Williams <codehelp@debian.org>:
Bug#426944; Package apt-cross. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <linux@codehelp.co.uk>:
Extra info received and forwarded to list. Copy sent to Neil Williams <codehelp@debian.org>. Full text and rfc822 format available.

Message #10 received at 426944@bugs.debian.org (full text, mbox):

From: Neil Williams <linux@codehelp.co.uk>
To: 426944@bugs.debian.org
Subject: multiple requests in one report
Date: Fri, 1 Jun 2007 08:14:46 +0100
[Message part 1 (text/plain, inline)]
> (One suggestion is that it could accept "install" as well as
> "--install", for more consistency with apt-get.  And a -s for
> simulate would also be appreciated.)

That's two wishlist bugs - I'm personally not convinced that supporting
-i|--install|install is worthwhile because apt-cross commands and
options do not always overlap the similar apt-get commands and options.
The two programs are related, of course, but I do not think it is wise
to make apt-cross mimic apt-get commands and options. apt-get is
intended for use with an entire distribution; apt-cross is only to make
foreign libraries and headers available to a cross-compiler. The
manpage makes the point that apt-cross cannot and should not seek to be
capable of installing or maintaining an entire cross install. Making
apt-cross too similar to apt-get would only increase the confusion
about the purpose of apt-cross.

At this time, I do not think that 'install' should be supported, only
--install or -i.

(Note that empdebuild {emdebian-tools} *does* mimic the underlying
pbuilder code and use the same options in the same way. That is because
it calls unchanged pbuilder functions directly
from /usr/lib/pbuilder/foo and it has been explicitly designed to be as
close to pbuilder and pdebuild as possible. Where there is clear
overlap, I would support use of the same commands and options but I do
not think this applies to apt-cross.)

The --simulate (the -s and -S options are already taken) option could
be added at some point in the future but there is a code rewrite
planned after DebConf so --simulate would have to wait until then. More
likely will be a --yes option and modified behaviour in --install so
that when the list of packages has been calculated, the user is
shown the list of packages and prompted to confirm installation. The
--yes option would override the prompt and provide the current
behaviour. i.e. the default would be --simulate or at least
--interactive. I think that is a better plan, overall. That is also
similar to apt-get, again raising the need to ensure that users are
clear on how apt-cross differs from apt-get.

(I've added that to the upstream TODO file so there is no need to file
a wishlist bug about that.)

=== main bug report ===

> So the bug is that for unstable and testing it seemed to
> automatically download the package files while for stable it didn't.

apt-cross isn't in stable. There are bugs in the dpkg-cross framework
in stable that are fixed in lenny and some bugs in lenny that have been
fixed in sid. At this time, apt-cross cannot realistically support
stable just as it cannot support oldstable. The next release will
depend on dpkg-dev >= 1.14 (via dpkg-cross >= 1.38) as a result of more
of these fixes which will make installation on stable impractical.

However, I need to see the output requested below before I can work out
why --update was not triggered in your case.

> And/or, that without the package files it printed only a very terse
> message, not "no packages files, please run apt-cross --update".

(The message has already been fixed upstream.)
 
> Here is the contents of my sources.list, exluding commented-out
> lines, in case it is relevent :

Actually, considerably more useful is the output of:

$ apt-cache policy

> Please excuse me if I am doing something stupid (or if you consider
> my expectations unreasonable!), and thank you for this excellent tool.

I wouldn't go that far but I think there are reasonable limits on what
apt-cross can actually support and etch just isn't quite at that level.
That said, there is a difference between running apt-cross on
unstable / testing and querying stable and trying to run apt-cross on
stable directly.

So a few requests for clarification please:

$ cat /etc/debian_version

$ apt-cache policy

Have you got similar content in ~/.dpkg-cross for stable as you have
for testing and unstable (judging just by filenames and file sizes)?

What is the content of ~/.dpkg-cross/stable/lists ?

-- 

Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/
[Message part 2 (application/pgp-signature, inline)]

Tags added: moreinfo Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Fri, 01 Jun 2007 07:18:08 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#426944; Package apt-cross. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #17 received at 426944@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 426944@bugs.debian.org
Subject: Re: Bug#426944: outdated dependencies
Date: Fri, 1 Jun 2007 09:08:25 +0100
[Message part 1 (text/plain, inline)]
> Versions of packages apt-cross depends on:
> ii  apt                           0.6.43.3   Advanced front-end for dpkg
> ii  binutils                      2.17-1     The GNU assembler, linker and bina
> ii  dpkg-cross                    1.28       tools for cross compiling Debian p

Please upgrade dpkg-dev and dpkg-cross too - stable (etch) has
dpkg-cross 1.32, testing (lenny) has 1.35. sid has 1.38 but the gcc4.2
transition means that this will not enter testing for a while (due to a
dependency on dpkg-dev >= 1.14).

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Bug 426944 cloned as bug 432132. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sat, 07 Jul 2007 20:42:02 GMT) Full text and rfc822 format available.

Severity set to `wishlist' from `normal' Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sat, 07 Jul 2007 20:42:03 GMT) Full text and rfc822 format available.

Changed Bug title to `apt-cross: please add a --simulate option' from `apt-cross: Silently fails with "-S stable" without --update'. Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sat, 07 Jul 2007 20:42:04 GMT) Full text and rfc822 format available.

Tags removed: moreinfo Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Sat, 07 Jul 2007 20:48:06 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#432132; Package apt-cross. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #30 received at 432132@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 432132@bugs.debian.org
Subject: --simulate option
Date: Sat, 7 Jul 2007 21:54:14 +0100
[Message part 1 (text/plain, inline)]
Cloned the previous bug to isolate just the request for the --simulate
option.

So far, I anticipate that simulate will only be supportable within
--install because --simulate will need to include output from 'dpkg
--simulate -i foo-$arch-cross_baz.deb' and this will mean that
'apt-cross --simulate --install foo' will still need to download and
build the package.

This also requires a second new option: --clean or --keep (not sure
which way to phrase it yet) which handles whether the temporary
archives are removed by apt-cross. Naturally, --simulate should imply
--keep (or --no-clean) to prevent repeat downloads. --install will (as
now) remove all temporary archives upon a successful install (i.e.
--install without --simulate implies --clean or --no-keep).

If --simulate produces output that the user finds unacceptable, --clean
(or similar) will be needed, with a hint to use that command at the end
of the simulate output.

BTW. It is very likely that this bug will be fixed in an Emdebian
interim release before the fix reaches Debian. Emdebian interim
releases use the release number of the version (0.2.x) and Debian
uploads use the minor version number (0.x.0). Generally, once the
Emdebian version is stable, the Debian version is uploaded.

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#432132; Package apt-cross. Full text and rfc822 format available.

Acknowledgement sent to Neil Williams <codehelp@debian.org>:
Extra info received and forwarded to list. Full text and rfc822 format available.

Message #35 received at 432132@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 432132@bugs.debian.org
Subject: Problems with --simulate
Date: Wed, 1 Aug 2007 23:30:47 +0100
[Message part 1 (text/plain, inline)]
I'm not sure I can implement --simulate in the expected manner - dpkg
--simulate does not provide the kind of output that would be useful:

$ sudo dpkg --no-act -i /opt/debian/pbuilder/result/foo-1_amd64.deb 
Selecting previously deselected package foo.
(Reading database ... 134416 files and directories currently installed.)
Unpacking foo (from .../foo-1_amd64.deb) ...

That's all I get - despite the fact that without --simulate I *know*
that the installation will fail because LOTS of dependencies of this
particular package are not installed. 

$ dpkg -l foo
No packages found matching foo

The package I used for this test does exist in the archive, so:
$ sudo apt-get install foo
...
0 upgraded, 12 newly installed, 0 to remove and 0 not upgraded.
Need to get 4911kB/80.1MB of archives.
After unpacking 167MB of additional disk space will be used.
Abort

$ sudo apt-get -f install
Reading package lists... Done
Building dependency tree       
Reading state information... Done
0 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.

$ sudo apt-get -m install
Reading package lists... Done
Building dependency tree       
Reading state information... Done
0 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.

dpkg just doesn't do what you expect from --simulate and therefore
neither can dpkg-cross or apt-cross.

apt-get --simulate DOES give the required information:
Inst texlive-common (2007-10 Debian:unstable)
Inst texlive-doc-base (2007-3 Debian:unstable)
Inst texlive-base-bin (2007-12 Debian:unstable)
Inst texlive-base (2007-10 Debian:unstable)
...

but apt-cross cannot use apt-get to do the installation of a local .deb
file.
:-(

-- 


Neil Williams
=============
http://www.data-freedom.org/
http://www.nosoftwarepatents.com/
http://www.linux.codehelp.co.uk/

[Message part 2 (application/pgp-signature, inline)]

Tags added: pending Request was from Neil Williams <codehelp@debian.org> to control@bugs.debian.org. (Wed, 29 Aug 2007 17:03:02 GMT) Full text and rfc822 format available.

Reply sent to Neil Williams <codehelp@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Phil Endecott <spam_from_debian_bugs_2@chezphil.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #42 received at 432132-close@bugs.debian.org (full text, mbox):

From: Neil Williams <codehelp@debian.org>
To: 432132-close@bugs.debian.org
Subject: Bug#432132: fixed in apt-cross 0.3.0
Date: Fri, 12 Oct 2007 18:39:24 +0000
Source: apt-cross
Source-Version: 0.3.0

We believe that the bug you reported is fixed in the latest version of
apt-cross, which is due to be installed in the Debian FTP archive:

apt-cross_0.3.0.dsc
  to pool/main/a/apt-cross/apt-cross_0.3.0.dsc
apt-cross_0.3.0.tar.gz
  to pool/main/a/apt-cross/apt-cross_0.3.0.tar.gz
apt-cross_0.3.0_all.deb
  to pool/main/a/apt-cross/apt-cross_0.3.0_all.deb
libcache-apt-perl_0.3.0_all.deb
  to pool/main/a/apt-cross/libcache-apt-perl_0.3.0_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 432132@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Neil Williams <codehelp@debian.org> (supplier of updated apt-cross package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 08 Oct 2007 22:29:17 +0100
Source: apt-cross
Binary: apt-cross libcache-apt-perl
Architecture: source all
Version: 0.3.0
Distribution: unstable
Urgency: low
Maintainer: Neil Williams <codehelp@debian.org>
Changed-By: Neil Williams <codehelp@debian.org>
Description: 
 apt-cross  - retrieve, build and install libraries for cross-compiling
 libcache-apt-perl - object oriented apt cache perl binding
Closes: 432132 440929 442012
Changes: 
 apt-cross (0.3.0) unstable; urgency=low
 .
   * New Debian release
 .
 apt-cross (0.2.9) unstable; urgency=low
 .
   * test branch created for merging NorthernCross into apt-cross
   * apt-nc-cross branch: Migrated to Debian::DpkgCross
   * Include test code from apt-rdepends to get the Depends info
     efficiently (incomplete)
   * apt-nc-cross branch: import files to create a test package.
   rename AptCross:: to Cache::Apt:: and Cache.pm to Lookup.pm
   * apt-cross: use apt-get in download-only mode to prepare the uri
   * apt-cross: add verbose output and mark some TODO items
   * Add apt-rdepends developer to our copyright
   * add build depends for manpage generation
   * Adding a --check option to meet the needs of emdebian-tools
   * Enforce 'use strict' across all source files
   * Cache::Apt::Lookup merging apt-rdepends code into AptCross calls
   * fixing strict warnings for
   * update copyright with details of contributors
   * apt-cross: separate host and target cache
   * Config.pm: allow host cache to locate Arch:all packages
   * Package.pm: implement a usable Depends output
   * Lookup.pm: replace NC dependency code with apt-rdepends code
   * hide init - not needed in exporter and duplicates existing symbol
   * please add a --simulate option (Closes: #432132)
   * apt-cross -i fails with certain unofficial repositories
   (Closes: #440929)
   * Add reportbug script to request apt-cache policy
   * apt-cross update looks in non-existing distribution
   (Closes: #442012) (actually an error relating to epoch handling.)
   * drop libdebian-dpkgcross-perl dependency from libcache-apt-perl
   * remove unused @removedeps support and allow ++ in package names
 .
 apt-cross (0.2.1) unstable; urgency=low
 .
   * Interim Emdebian release
   - fix handling of unknown packages.
   - implement --no-list-cleanup option for all calls to apt-get update
   to preserve Package and Source lists when switching between arches
   - Prevent apt dying if a particular archive does not support a particular
   suite by always giving apt an empty file in ~/.dpkg-cross/$suite/lists
Files: 
 5daf0eeb345d4871a3a294c865afda81 736 utils extra apt-cross_0.3.0.dsc
 74e5ee151765783795f0afc03dc9c2e8 26058 utils extra apt-cross_0.3.0.tar.gz
 02f32704949fe2fffab0a8544f988e2b 17398 utils extra apt-cross_0.3.0_all.deb
 7eed524516f57b718af06bd26ebcbf8d 27862 utils extra libcache-apt-perl_0.3.0_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFHCqJqiAEJSii8s+MRAoPRAJ0Y9q+jufbTXi+Xbwcquw2AE/y3VwCgyFc2
KKSes6F8PRzLWnUq1gjOgRM=
=jpIz
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 26 Nov 2007 07:27:47 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 17:01:41 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.